    001/*
    002 * Copyright (c) 2007-2016 Concurrent, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.flow.local.stream.element;
    022
    023import cascading.flow.FlowElement;
    024import cascading.flow.FlowProcess;
    025import cascading.flow.stream.duct.Duct;
    026import cascading.flow.stream.element.MergeStage;
    027import cascading.tuple.TupleEntry;
    028
    029/** A version of Merge that synchronizes the receives for local mode */
    030public class SyncMergeStage extends MergeStage
    031  {
    032  public SyncMergeStage( FlowProcess flowProcess, FlowElement flowElement )
    033    {
    034    super( flowProcess, flowElement );
    035    }
    036
    037  /**
    038   * synchronized, as by default, each source gets its turn, no concurrent threads. Except in local mode
    039   *
    040   * @param previous
    041   * @param tupleEntry
    042   */
    043  @Override
    044  public synchronized void receive( Duct previous, TupleEntry tupleEntry )
    045    {
    046    super.receive( previous, tupleEntry );
    047    }
    048  }